#include "RefCount.h"
typedef unsigned int size_t; /* appropriate for 32-bit Debian Linux */
void *malloc(size_t size);
void free(void *ptr);
long int random(void);


struct RefCount_t *createRefCount(void)
{
  struct RefCount_t *result = malloc(sizeof(struct RefCount_t));
  result->refcount = 1;
  result->num = random();
  return result;
}

void addRef(struct RefCount_t *ref)
{
  ++(ref->refcount);
}

void deleteRef(struct RefCount_t *ref)
{
  if (--(ref->refcount) == 0) {
    free(ref);
  }
}
