#include "RefCount.h"

extern int printf(const char *,...);

struct C_Container;

struct C_Container *
createContainer(void);

void
destroyContainer(struct C_Container *cont);

int
getSize(struct C_Container *cont);

void
addItem(struct C_Container *cont,
	struct RefCount_t *newItem);

struct RefCount_t *
getItem(struct C_Container *cont, int ind);

int main(int argc, char **argv)
{
  long max = -1;
  struct C_Container *cont = createContainer();
  struct RefCount_t *item = createRefCount();
  addItem(cont, item);
  deleteRef(item);
  item = getItem(cont, 0);
  max = item->num;
  deleteRef(item);
  printf("Max value: %ld\n", max);
  destroyContainer(cont);
}
